
c========================================================================
      SUBROUTINE CALC(this_kp, this_en, this_lt,
     >                     mean_e_all,mean_e_low,mean_e_mid,mean_e_high,
     >                      std_e_all, std_e_low, std_e_mid, std_e_high,
     >                     five_e_all,five_e_low,five_e_mid,five_e_high,
     >                 tfive_e_all,tfive_e_low,tfive_e_mid,tfive_e_high,
     >                      med_e_all, med_e_low, med_e_mid, med_e_high,
     >                 sfive_e_all,sfive_e_low,sfive_e_mid,sfive_e_high,
     >                 nfive_e_all,nfive_e_low,nfive_e_mid,nfive_e_high,
     >                     mean_i_all,mean_i_low,mean_i_mid,mean_i_high,
     >                      std_i_all, std_i_low, std_i_mid, std_i_high,
     >                     five_i_all,five_i_low,five_i_mid,five_i_high,
     >                 tfive_i_all,tfive_i_low,tfive_i_mid,tfive_i_high,
     >                      med_i_all, med_i_low, med_i_mid, med_i_high,
     >                 sfive_i_all,sfive_i_low,sfive_i_mid,sfive_i_high,
     >                 nfive_i_all,nfive_i_low,nfive_i_mid,nfive_i_high, 
     >              final_e_all, final_e_low, final_e_mid, final_e_high,
     >              final_i_all, final_i_low, final_i_mid, final_i_high)
c========================================================================
c  calc.f
c  Calculate and return the model flux arrays for electron and ions

      IMPLICIT NONE

c     DEFINE INTEGER VARIABLES
      INTEGER(KIND=8) KPS, ENS, LTS, VALS
      INTEGER(KIND=8) this_kp
      INTEGER(KIND=8) IDX, IDY, e0_e, e1_e, e0_i, e1_i, lt0, lt1
      INTEGER(KIND=8) I, J, K

c     DEFINE PARAMETERS
      PARAMETER(KPS=28, ENS=40, LTS=24, VALS=7)

c     DEFINE REAL ARRAYS
      REAL(KIND=8) mean_e_all(KPS,ENS,LTS)
      REAL(KIND=8) std_e_all(KPS,ENS,LTS)
      REAL(KIND=8) five_e_all(KPS,ENS,LTS)
      REAL(KIND=8) tfive_e_all(KPS,ENS,LTS)
      REAL(KIND=8) med_e_all(KPS,ENS,LTS)
      REAL(KIND=8) sfive_e_all(KPS,ENS,LTS)
      REAL(KIND=8) nfive_e_all(KPS,ENS,LTS)

      REAL(KIND=8) mean_e_low(KPS,ENS,LTS)
      REAL(KIND=8) std_e_low(KPS,ENS,LTS)
      REAL(KIND=8) five_e_low(KPS,ENS,LTS)
      REAL(KIND=8) tfive_e_low(KPS,ENS,LTS)
      REAL(KIND=8) med_e_low(KPS,ENS,LTS)
      REAL(KIND=8) sfive_e_low(KPS,ENS,LTS)
      REAL(KIND=8) nfive_e_low(KPS,ENS,LTS)

      REAL(KIND=8) mean_e_mid(KPS,ENS,LTS)
      REAL(KIND=8) std_e_mid(KPS,ENS,LTS)
      REAL(KIND=8) five_e_mid(KPS,ENS,LTS)
      REAL(KIND=8) tfive_e_mid(KPS,ENS,LTS)
      REAL(KIND=8) med_e_mid(KPS,ENS,LTS)
      REAL(KIND=8) sfive_e_mid(KPS,ENS,LTS)
      REAL(KIND=8) nfive_e_mid(KPS,ENS,LTS)

      REAL(KIND=8) mean_e_high(KPS,ENS,LTS)
      REAL(KIND=8) std_e_high(KPS,ENS,LTS)
      REAL(KIND=8) five_e_high(KPS,ENS,LTS)
      REAL(KIND=8) tfive_e_high(KPS,ENS,LTS)
      REAL(KIND=8) med_e_high(KPS,ENS,LTS)
      REAL(KIND=8) sfive_e_high(KPS,ENS,LTS)
      REAL(KIND=8) nfive_e_high(KPS,ENS,LTS)

      REAL(KIND=8) mean_i_all(KPS,ENS,LTS)
      REAL(KIND=8) std_i_all(KPS,ENS,LTS)
      REAL(KIND=8) five_i_all(KPS,ENS,LTS)
      REAL(KIND=8) tfive_i_all(KPS,ENS,LTS)
      REAL(KIND=8) med_i_all(KPS,ENS,LTS)
      REAL(KIND=8) sfive_i_all(KPS,ENS,LTS)
      REAL(KIND=8) nfive_i_all(KPS,ENS,LTS)

      REAL(KIND=8) mean_i_low(KPS,ENS,LTS)
      REAL(KIND=8) std_i_low(KPS,ENS,LTS)
      REAL(KIND=8) five_i_low(KPS,ENS,LTS)
      REAL(KIND=8) tfive_i_low(KPS,ENS,LTS)
      REAL(KIND=8) med_i_low(KPS,ENS,LTS)
      REAL(KIND=8) sfive_i_low(KPS,ENS,LTS)
      REAL(KIND=8) nfive_i_low(KPS,ENS,LTS)

      REAL(KIND=8) mean_i_mid(KPS,ENS,LTS)
      REAL(KIND=8) std_i_mid(KPS,ENS,LTS)
      REAL(KIND=8) five_i_mid(KPS,ENS,LTS)
      REAL(KIND=8) tfive_i_mid(KPS,ENS,LTS)
      REAL(KIND=8) med_i_mid(KPS,ENS,LTS)
      REAL(KIND=8) sfive_i_mid(KPS,ENS,LTS)
      REAL(KIND=8) nfive_i_mid(KPS,ENS,LTS)

      REAL(KIND=8) mean_i_high(KPS,ENS,LTS)
      REAL(KIND=8) std_i_high(KPS,ENS,LTS)
      REAL(KIND=8) five_i_high(KPS,ENS,LTS)
      REAL(KIND=8) tfive_i_high(KPS,ENS,LTS)
      REAL(KIND=8) med_i_high(KPS,ENS,LTS)
      REAL(KIND=8) sfive_i_high(KPS,ENS,LTS)
      REAL(KIND=8) nfive_i_high(KPS,ENS,LTS)

      REAL(KIND=8) final_e_all(VALS),  final_i_all(VALS)
      REAL(KIND=8) final_e_low(VALS),  final_i_low(VALS)
      REAL(KIND=8) final_e_mid(VALS),  final_i_mid(VALS)
      REAL(KIND=8) final_e_high(VALS), final_i_high(VALS)

      REAL(KIND=8) en_he(ENS),en_hp(ENS),log_en_he(ENS),log_en_hp(ENS)

c     DEFINE REAL VARIABLES
      REAL(KIND=8) this_en, this_lt, log_this_en
      REAL(KIND=8) flux_11, flux_12, flux_21, flux_22
      REAL(KIND=8) x1, x2, y1, y2, R1, R2, Q1, Q2, P
      REAL(KIND=8) x, y

c    FILL AVERAGE CENTRE ENERGIES, NORMALISED BY SATELLITE
      DATA en_he/
     >     1.034126D0,     1.346516D0,     1.817463D0,     2.399564D0, 
     >     3.161048D0,     4.153217D0,     5.539430D0,     7.464148D0,
     >     9.836741D0,    12.543499D0,    16.062061D0,    20.876962D0,
     >    27.183572D0,    35.843437D0,    47.179073D0,    61.424732D0,
     >    80.120170D0,   104.563461D0,   136.914871D0,   179.740982D0,
     >   235.406829D0,   309.020721D0,   405.806213D0,   532.664123D0,
     >   699.243896D0,   917.146484D0,  1205.174438D0,  1582.510986D0,
     >  2069.619628D0,  2703.301269D0,  3540.124511D0,  4639.775390D0,
     >  6069.347656D0,  7957.457519D0, 10436.841796D0, 13677.195312D0,
     > 17923.560546D0, 23488.560546D0, 30782.000000D0, 40326.937500D0/

      DATA en_hp/
     >     1.816424D0,     2.284231D0,     2.904752D0,     3.639589D0, 
     >     4.483188D0,     5.671049D0,     7.343667D0,     9.450922D0,
     >    11.934194D0,    15.105951D0,    19.372854D0,    24.943658D0,
     >    32.053474D0,    41.142940D0,    53.239536D0,    68.940170D0,
     >    89.082473D0,   115.585487D0,   150.529022D0,   196.249755D0,
     >   256.610107D0,   335.709136D0,   439.549621D0,   574.766357D0,
     >   749.907531D0,   982.261108D0,  1278.967041D0,  1662.856079D0,
     >  2170.886474D0,  2829.989013D0,  3691.509765D0,  4822.499023D0,
     >  6300.260742D0,  8217.569335D0, 10726.390625D0, 14001.280273D0,
     > 18276.244140D0, 23856.085937D0, 31140.962890D0, 40649.562500D0/
     
c     DEFINE REAL FUNCTIONS
      REAL(KIND=8) BILINEAR

c     CONVERT ENERGIES TO LOG10
      DO 10 I=1,ENS
        log_en_he(I)=DLOG10(en_he(I))
        log_en_hp(I)=DLOG10(en_hp(I))
 10   CONTINUE 

      log_this_en=DLOG10(this_en)

c     =====================ELECTRONS===================================
c
c     FIND THE NEAREST NEIGHBOURS IN ENERGY (ELECTRONS)
      IDX=1
 20   IF (log_en_he(IDX).LT.log_this_en) THEN 
c        PRINT*, log_en_he(IDX), log_this_en
        IDX=IDX+1
        GOTO 20
      ENDIF
      e0_e=IDX-1
      e1_e=IDX

c     BRACKET IN LOCAL TIME
c     DATA ARRAY WRITTEN FROM 0 to 23 LT
      lt0=FLOOR(this_lt+1)
      lt1=CEILING(this_lt+1)
c     ALLOW FOR WRAPPING AROUND MIDNIGHT IN LT
      IF (lt1.EQ.25) lt1=1

c     SET LTs TO ACTUAL VALS AND CONVERT ENERGIES TO LOGS
      x1=lt0-1
      x2=lt1-1
      y1=log_en_he(e0_e)
      y2=log_en_he(e1_e)
      x=this_lt
      y=log_this_en

c     ==========Now get the fluxes for ALL F10.7========================
c
c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (E)
c     Mean
      flux_11=mean_e_all(this_kp, e0_e, lt0)
      flux_12=mean_e_all(this_kp, e1_e, lt0)
      flux_21=mean_e_all(this_kp, e0_e, lt1)
      flux_22=mean_e_all(this_kp, e1_e, lt1)
      final_e_all(1)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (E)
c     Standard Deviation
      flux_11=std_e_all(this_kp, e0_e, lt0)
      flux_12=std_e_all(this_kp, e1_e, lt0)
      flux_21=std_e_all(this_kp, e0_e, lt1)
      flux_22=std_e_all(this_kp, e1_e, lt1)
      final_e_all(2)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (E)
c     5th Percentile
      flux_11=five_e_all(this_kp, e0_e, lt0)
      flux_12=five_e_all(this_kp, e1_e, lt0)
      flux_21=five_e_all(this_kp, e0_e, lt1)
      flux_22=five_e_all(this_kp, e1_e, lt1)
      final_e_all(3)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (E)
c     25th Percentile
      flux_11=tfive_e_all(this_kp, e0_e, lt0)
      flux_12=tfive_e_all(this_kp, e1_e, lt0)
      flux_21=tfive_e_all(this_kp, e0_e, lt1)
      flux_22=tfive_e_all(this_kp, e1_e, lt1)
      final_e_all(4)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (E)
c     Median
      flux_11=med_e_all(this_kp, e0_e, lt0)
      flux_12=med_e_all(this_kp, e1_e, lt0)
      flux_21=med_e_all(this_kp, e0_e, lt1)
      flux_22=med_e_all(this_kp, e1_e, lt1)
      final_e_all(5)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (E)
c     75th Percentile
      flux_11=sfive_e_all(this_kp, e0_e, lt0)
      flux_12=sfive_e_all(this_kp, e1_e, lt0)
      flux_21=sfive_e_all(this_kp, e0_e, lt1)
      flux_22=sfive_e_all(this_kp, e1_e, lt1)
      final_e_all(6)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (E)
c     95th Percentile
      flux_11=nfive_e_all(this_kp, e0_e, lt0)
      flux_12=nfive_e_all(this_kp, e1_e, lt0)
      flux_21=nfive_e_all(this_kp, e0_e, lt1)
      flux_22=nfive_e_all(this_kp, e1_e, lt1)
      final_e_all(7)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     ==========Now get the fluxes for LOW F10.7========================

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (E)
c     Mean
      flux_11=mean_e_low(this_kp, e0_e, lt0)
      flux_12=mean_e_low(this_kp, e1_e, lt0)
      flux_21=mean_e_low(this_kp, e0_e, lt1)
      flux_22=mean_e_low(this_kp, e1_e, lt1)
      final_e_low(1)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (E)
c     Standard Deviation
      flux_11=std_e_low(this_kp, e0_e, lt0)
      flux_12=std_e_low(this_kp, e1_e, lt0)
      flux_21=std_e_low(this_kp, e0_e, lt1)
      flux_22=std_e_low(this_kp, e1_e, lt1)
      final_e_low(2)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (E)
c     5th Percentile
      flux_11=five_e_low(this_kp, e0_e, lt0)
      flux_12=five_e_low(this_kp, e1_e, lt0)
      flux_21=five_e_low(this_kp, e0_e, lt1)
      flux_22=five_e_low(this_kp, e1_e, lt1)
      final_e_low(3)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (E)
c     25th Percentile
      flux_11=tfive_e_low(this_kp, e0_e, lt0)
      flux_12=tfive_e_low(this_kp, e1_e, lt0)
      flux_21=tfive_e_low(this_kp, e0_e, lt1)
      flux_22=tfive_e_low(this_kp, e1_e, lt1)
      final_e_low(4)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (E)
c     Median
      flux_11=med_e_low(this_kp, e0_e, lt0)
      flux_12=med_e_low(this_kp, e1_e, lt0)
      flux_21=med_e_low(this_kp, e0_e, lt1)
      flux_22=med_e_low(this_kp, e1_e, lt1)
      final_e_low(5)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (E)
c     75th Percentile
      flux_11=sfive_e_low(this_kp, e0_e, lt0)
      flux_12=sfive_e_low(this_kp, e1_e, lt0)
      flux_21=sfive_e_low(this_kp, e0_e, lt1)
      flux_22=sfive_e_low(this_kp, e1_e, lt1)
      final_e_low(6)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (E)
c     95th Percentile
      flux_11=nfive_e_low(this_kp, e0_e, lt0)
      flux_12=nfive_e_low(this_kp, e1_e, lt0)
      flux_21=nfive_e_low(this_kp, e0_e, lt1)
      flux_22=nfive_e_low(this_kp, e1_e, lt1)
      final_e_low(7)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     ==========Now get the fluxes for MID F10.7========================

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (E)
c     Mean
      flux_11=mean_e_mid(this_kp, e0_e, lt0)
      flux_12=mean_e_mid(this_kp, e1_e, lt0)
      flux_21=mean_e_mid(this_kp, e0_e, lt1)
      flux_22=mean_e_mid(this_kp, e1_e, lt1)
      final_e_mid(1)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (E)
c     Standard Deviation
      flux_11=std_e_mid(this_kp, e0_e, lt0)
      flux_12=std_e_mid(this_kp, e1_e, lt0)
      flux_21=std_e_mid(this_kp, e0_e, lt1)
      flux_22=std_e_mid(this_kp, e1_e, lt1)
      final_e_mid(2)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (E)
c     5th Percentile
      flux_11=five_e_mid(this_kp, e0_e, lt0)
      flux_12=five_e_mid(this_kp, e1_e, lt0)
      flux_21=five_e_mid(this_kp, e0_e, lt1)
      flux_22=five_e_mid(this_kp, e1_e, lt1)
      final_e_mid(3)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (E)
c     25th Percentile
      flux_11=tfive_e_mid(this_kp, e0_e, lt0)
      flux_12=tfive_e_mid(this_kp, e1_e, lt0)
      flux_21=tfive_e_mid(this_kp, e0_e, lt1)
      flux_22=tfive_e_mid(this_kp, e1_e, lt1)
      final_e_mid(4)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (E)
c     Median
      flux_11=med_e_mid(this_kp, e0_e, lt0)
      flux_12=med_e_mid(this_kp, e1_e, lt0)
      flux_21=med_e_mid(this_kp, e0_e, lt1)
      flux_22=med_e_mid(this_kp, e1_e, lt1)
      final_e_mid(5)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (E)
c     75th Percentile
      flux_11=sfive_e_mid(this_kp, e0_e, lt0)
      flux_12=sfive_e_mid(this_kp, e1_e, lt0)
      flux_21=sfive_e_mid(this_kp, e0_e, lt1)
      flux_22=sfive_e_mid(this_kp, e1_e, lt1)
      final_e_mid(6)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (E)
c     95th Percentile
      flux_11=nfive_e_mid(this_kp, e0_e, lt0)
      flux_12=nfive_e_mid(this_kp, e1_e, lt0)
      flux_21=nfive_e_mid(this_kp, e0_e, lt1)
      flux_22=nfive_e_mid(this_kp, e1_e, lt1)
      final_e_mid(7)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     ==========Now get the fluxes for HIGH F10.7=======================

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (E)
c     Mean
      flux_11=mean_e_high(this_kp, e0_e, lt0)
      flux_12=mean_e_high(this_kp, e1_e, lt0)
      flux_21=mean_e_high(this_kp, e0_e, lt1)
      flux_22=mean_e_high(this_kp, e1_e, lt1)
      final_e_high(1)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (E)
c     Standard Deviation
      flux_11=std_e_high(this_kp, e0_e, lt0)
      flux_12=std_e_high(this_kp, e1_e, lt0)
      flux_21=std_e_high(this_kp, e0_e, lt1)
      flux_22=std_e_high(this_kp, e1_e, lt1)
      final_e_high(2)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (E)
c     5th Percentile
      flux_11=five_e_high(this_kp, e0_e, lt0)
      flux_12=five_e_high(this_kp, e1_e, lt0)
      flux_21=five_e_high(this_kp, e0_e, lt1)
      flux_22=five_e_high(this_kp, e1_e, lt1)
      final_e_high(3)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (E)
c     25th Percentile
      flux_11=tfive_e_high(this_kp, e0_e, lt0)
      flux_12=tfive_e_high(this_kp, e1_e, lt0)
      flux_21=tfive_e_high(this_kp, e0_e, lt1)
      flux_22=tfive_e_high(this_kp, e1_e, lt1)
      final_e_high(4)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (E)
c     Median
      flux_11=med_e_high(this_kp, e0_e, lt0)
      flux_12=med_e_high(this_kp, e1_e, lt0)
      flux_21=med_e_high(this_kp, e0_e, lt1)
      flux_22=med_e_high(this_kp, e1_e, lt1)
      final_e_high(5)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (E)
c     75th Percentile
      flux_11=sfive_e_high(this_kp, e0_e, lt0)
      flux_12=sfive_e_high(this_kp, e1_e, lt0)
      flux_21=sfive_e_high(this_kp, e0_e, lt1)
      flux_22=sfive_e_high(this_kp, e1_e, lt1)
      final_e_high(6)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (E)
c     95th Percentile
      flux_11=nfive_e_high(this_kp, e0_e, lt0)
      flux_12=nfive_e_high(this_kp, e1_e, lt0)
      flux_21=nfive_e_high(this_kp, e0_e, lt1)
      flux_22=nfive_e_high(this_kp, e1_e, lt1)
      final_e_high(7)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c
c     =====================IONS========================================
c
c     FIND THE NEAREST NEIGHBOURS IN ENERGY (IONS)
      IDY=1
 30   IF (log_en_hp(IDY).LT.log_this_en) THEN 
        IDY=IDY+1
        GOTO 30
      ENDIF
      e0_i=IDY-1
      e1_i=IDY

c     SET LTs TO ACTUAL VALS AND CONVERT ENERGIES TO LOGS
c     ***y1 and y2 were using electron energies in V0.1.  Thanks 
c     for spotting this to Jesse Woodroffe.
      y1=log_en_hp(e0_i)
      y2=log_en_hp(e1_i)

c     ==========Now get the fluxes for ALL F10.7========================
c
c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (I)
c     Mean
      flux_11=mean_i_all(this_kp, e0_i, lt0)
      flux_12=mean_i_all(this_kp, e1_i, lt0)
      flux_21=mean_i_all(this_kp, e0_i, lt1)
      flux_22=mean_i_all(this_kp, e1_i, lt1)
      final_i_all(1)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (I)
c     Standard Deviation
      flux_11=std_i_all(this_kp, e0_i, lt0)
      flux_12=std_i_all(this_kp, e1_i, lt0)
      flux_21=std_i_all(this_kp, e0_i, lt1)
      flux_22=std_i_all(this_kp, e1_i, lt1)
      final_i_all(2)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (I)
c     5th Percentile
      flux_11=five_i_all(this_kp, e0_i, lt0)
      flux_12=five_i_all(this_kp, e1_i, lt0)
      flux_21=five_i_all(this_kp, e0_i, lt1)
      flux_22=five_i_all(this_kp, e1_i, lt1)
      final_i_all(3)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (I)
c     25th Percentile
      flux_11=tfive_i_all(this_kp, e0_i, lt0)
      flux_12=tfive_i_all(this_kp, e1_i, lt0)
      flux_21=tfive_i_all(this_kp, e0_i, lt1)
      flux_22=tfive_i_all(this_kp, e1_i, lt1)
      final_i_all(4)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (I)
c     Median
      flux_11=med_i_all(this_kp, e0_i, lt0)
      flux_12=med_i_all(this_kp, e1_i, lt0)
      flux_21=med_i_all(this_kp, e0_i, lt1)
      flux_22=med_i_all(this_kp, e1_i, lt1)
      final_i_all(5)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (I)
c     75th Percentile
      flux_11=sfive_i_all(this_kp, e0_i, lt0)
      flux_12=sfive_i_all(this_kp, e1_i, lt0)
      flux_21=sfive_i_all(this_kp, e0_i, lt1)
      flux_22=sfive_i_all(this_kp, e1_i, lt1)
      final_i_all(6)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (I)
c     95th Percentile
      flux_11=nfive_i_all(this_kp, e0_i, lt0)
      flux_12=nfive_i_all(this_kp, e1_i, lt0)
      flux_21=nfive_i_all(this_kp, e0_i, lt1)
      flux_22=nfive_i_all(this_kp, e1_i, lt1)
      final_i_all(7)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     ==========Now get the fluxes for LOW F10.7========================

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (I)
c     Mean
      flux_11=mean_i_low(this_kp, e0_i, lt0)
      flux_12=mean_i_low(this_kp, e1_i, lt0)
      flux_21=mean_i_low(this_kp, e0_i, lt1)
      flux_22=mean_i_low(this_kp, e1_i, lt1)
      final_i_low(1)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (I)
c     Standard Deviation
      flux_11=std_i_low(this_kp, e0_i, lt0)
      flux_12=std_i_low(this_kp, e1_i, lt0)
      flux_21=std_i_low(this_kp, e0_i, lt1)
      flux_22=std_i_low(this_kp, e1_i, lt1)
      final_i_low(2)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (I)
c     5th Percentile
      flux_11=five_i_low(this_kp, e0_i, lt0)
      flux_12=five_i_low(this_kp, e1_i, lt0)
      flux_21=five_i_low(this_kp, e0_i, lt1)
      flux_22=five_i_low(this_kp, e1_i, lt1)
      final_i_low(3)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (I)
c     25th Percentile
      flux_11=tfive_i_low(this_kp, e0_i, lt0)
      flux_12=tfive_i_low(this_kp, e1_i, lt0)
      flux_21=tfive_i_low(this_kp, e0_i, lt1)
      flux_22=tfive_i_low(this_kp, e1_i, lt1)
      final_i_low(4)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (I)
c     Median
      flux_11=med_i_low(this_kp, e0_i, lt0)
      flux_12=med_i_low(this_kp, e1_i, lt0)
      flux_21=med_i_low(this_kp, e0_i, lt1)
      flux_22=med_i_low(this_kp, e1_i, lt1)
      final_i_low(5)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (I)
c     75th Percentile
      flux_11=sfive_i_low(this_kp, e0_i, lt0)
      flux_12=sfive_i_low(this_kp, e1_i, lt0)
      flux_21=sfive_i_low(this_kp, e0_i, lt1)
      flux_22=sfive_i_low(this_kp, e1_i, lt1)
      final_i_low(6)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (I)
c     95th Percentile
      flux_11=nfive_i_low(this_kp, e0_i, lt0)
      flux_12=nfive_i_low(this_kp, e1_i, lt0)
      flux_21=nfive_i_low(this_kp, e0_i, lt1)
      flux_22=nfive_i_low(this_kp, e1_i, lt1)
      final_i_low(7)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     ==========Now get the fluxes for MID F10.7========================

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (I)
c     Mean
      flux_11=mean_i_mid(this_kp, e0_i, lt0)
      flux_12=mean_i_mid(this_kp, e1_i, lt0)
      flux_21=mean_i_mid(this_kp, e0_i, lt1)
      flux_22=mean_i_mid(this_kp, e1_i, lt1)
      final_i_mid(1)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (I)
c     Standard Deviation
      flux_11=std_i_mid(this_kp, e0_i, lt0)
      flux_12=std_i_mid(this_kp, e1_i, lt0)
      flux_21=std_i_mid(this_kp, e0_i, lt1)
      flux_22=std_i_mid(this_kp, e1_i, lt1)
      final_i_mid(2)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (I)
c     5th Percentile
      flux_11=five_i_mid(this_kp, e0_i, lt0)
      flux_12=five_i_mid(this_kp, e1_i, lt0)
      flux_21=five_i_mid(this_kp, e0_i, lt1)
      flux_22=five_i_mid(this_kp, e1_i, lt1)
      final_i_mid(3)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (I)
c     25th Percentile
      flux_11=tfive_i_mid(this_kp, e0_i, lt0)
      flux_12=tfive_i_mid(this_kp, e1_i, lt0)
      flux_21=tfive_i_mid(this_kp, e0_i, lt1)
      flux_22=tfive_i_mid(this_kp, e1_i, lt1)
      final_i_mid(4)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (I)
c     Median
      flux_11=med_i_mid(this_kp, e0_i, lt0)
      flux_12=med_i_mid(this_kp, e1_i, lt0)
      flux_21=med_i_mid(this_kp, e0_i, lt1)
      flux_22=med_i_mid(this_kp, e1_i, lt1)
      final_i_mid(5)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (I)
c     75th Percentile
      flux_11=sfive_i_mid(this_kp, e0_i, lt0)
      flux_12=sfive_i_mid(this_kp, e1_i, lt0)
      flux_21=sfive_i_mid(this_kp, e0_i, lt1)
      flux_22=sfive_i_mid(this_kp, e1_i, lt1)
      final_i_mid(6)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (I)
c     95th Percentile
      flux_11=nfive_i_mid(this_kp, e0_i, lt0)
      flux_12=nfive_i_mid(this_kp, e1_i, lt0)
      flux_21=nfive_i_mid(this_kp, e0_i, lt1)
      flux_22=nfive_i_mid(this_kp, e1_i, lt1)
      final_i_mid(7)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     ==========Now get the fluxes for HIGH F10.7=======================

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (I)
c     Mean
      flux_11=mean_i_high(this_kp, e0_i, lt0)
      flux_12=mean_i_high(this_kp, e1_i, lt0)
      flux_21=mean_i_high(this_kp, e0_i, lt1)
      flux_22=mean_i_high(this_kp, e1_i, lt1)
      final_i_high(1)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (I)
c     Standard Deviation
      flux_11=std_i_high(this_kp, e0_i, lt0)
      flux_12=std_i_high(this_kp, e1_i, lt0)
      flux_21=std_i_high(this_kp, e0_i, lt1)
      flux_22=std_i_high(this_kp, e1_i, lt1)
      final_i_high(2)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (I)
c     5th Percentile
      flux_11=five_i_high(this_kp, e0_i, lt0)
      flux_12=five_i_high(this_kp, e1_i, lt0)
      flux_21=five_i_high(this_kp, e0_i, lt1)
      flux_22=five_i_high(this_kp, e1_i, lt1)
      final_i_high(3)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (I)
c     25th Percentile
      flux_11=tfive_i_high(this_kp, e0_i, lt0)
      flux_12=tfive_i_high(this_kp, e1_i, lt0)
      flux_21=tfive_i_high(this_kp, e0_i, lt1)
      flux_22=tfive_i_high(this_kp, e1_i, lt1)
      final_i_high(4)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (I)
c     Median
      flux_11=med_i_high(this_kp, e0_i, lt0)
      flux_12=med_i_high(this_kp, e1_i, lt0)
      flux_21=med_i_high(this_kp, e0_i, lt1)
      flux_22=med_i_high(this_kp, e1_i, lt1)
      final_i_high(5)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (I)
c     75th Percentile
      flux_11=sfive_i_high(this_kp, e0_i, lt0)
      flux_12=sfive_i_high(this_kp, e1_i, lt0)
      flux_21=sfive_i_high(this_kp, e0_i, lt1)
      flux_22=sfive_i_high(this_kp, e1_i, lt1)
      final_i_high(6)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c     GET FOUR NEAREST NEIGHBOUR FLUX VALUES TO THE CHOSEN POINT (E)
c     95th Percentile
      flux_11=nfive_i_high(this_kp, e0_i, lt0)
      flux_12=nfive_i_high(this_kp, e1_i, lt0)
      flux_21=nfive_i_high(this_kp, e0_i, lt1)
      flux_22=nfive_i_high(this_kp, e1_i, lt1)
      final_i_high(7)=
     >        BILINEAR(x1,x2,y1,y2,x,y,flux_11,flux_12,flux_21,flux_22)

c      WRITE(6,*) '--- CALCULATIONS COMPLETE ---'

      RETURN

      END
c===================END SUBROUTINE CALC==================================
